;  $Id: thecolor.pro,v 1.1 2008/05/21 09:38:33 aake Exp $

FUNCTION nearest_color, ri, gi, bi
  common colors, ro, go, bo, rr, gg, bb

  if n_elements(rr) eq 0 then loadct, 39
  m=min((rr-long(ri))^2+(gg-long(gi))^2+(bb-long(bi))^2,k)
  if (m gt 200L^2) then begin
    loadct, 39
    m=min((rr-long(ri))^2+(gg-long(gi))^2+(bb-long(bi))^2,k)
  endif
  return, k
END

PRO init_color
  common ccolors, ic, cname

  n=10
  ic=intarr(n)
  cname=strarr(n)

  i=-1
  i=i+1 & ic(i)=nearest_color(000, 000, 000) & cname(i)='black'
  i=i+1 & ic(i)=nearest_color(255, 000, 000) & cname(i)='red'
  i=i+1 & ic(i)=nearest_color(000, 255, 000) & cname(i)='green'
  i=i+1 & ic(i)=nearest_color(000, 000, 255) & cname(i)='blue'
  i=i+1 & ic(i)=nearest_color(255, 255, 000) & cname(i)='yellow'
  i=i+1 & ic(i)=nearest_color(000, 255, 255) & cname(i)='cyan'
  i=i+1 & ic(i)=nearest_color(255, 000, 255) & cname(i)='magenta'
  i=i+1 & ic(i)=nearest_color(210, 150, 000) & cname(i)='orange'

  ic=ic(0:i)
  cname=cname(0:i)
END

FUNCTION thecolor, name
  common ccolors, ic, cname
  init_color
  color = STRLOWCASE(name)
  i=where(cname eq color)
  i=i(0)
  if i ge 0 then return,ic(i) else return,!d.table_size-1
END
