
loadct,39                                                                       ; rainbow color table
device,decompose=0                                                              ; make sure color shows

image = dist(256) + 10.*randomn(1, 256, 256)                                    ; image + 10 times stronger random noise
denoise = WV_DENOISE(image, 'Daubechies', 2, COEFF=100)                         ; Keep only 100 out of 16384 coefficients:  
window, xsize=256*3, ysize=2*155                                                ; window for images
tvscl, image, 0                                                                 ; original image
tvscl, denoise, 1                                                               ; denoised image
xyouts, [2*64, 2*196, 3*256-2*64], [5, 5, 5], ['Image', 'Filtered', 'Soft'], $  ; figure text
   /device, align=0.5, charsize=2  
denoise2 = WV_DENOISE(image, 'Daubechies', 2, COEFF=100, THRESHOLD=1)           ; change to "soft" threshold
tvscl, denoise2, 2                                                              ; show resulting image
   
END
